orte/mca/oob/tcp/oob_tcp.h File Reference.TH "orte/mca/oob/tcp/oob_tcp.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/mca/oob/tcp/oob_tcp.h \- Defines the functions for the tcp module. 
.SH SYNOPSIS
.br
.PP
\fC#include 'mca/oob/oob.h'\fP
.br
\fC#include 'mca/oob/base/base.h'\fP
.br
\fC#include 'mca/base/base.h'\fP
.br
\fC#include 'mca/ns/ns_types.h'\fP
.br
\fC#include 'opal/class/opal_free_list.h'\fP
.br
\fC#include 'class/opal_hash_table.h'\fP
.br
\fC#include 'opal/event/event.h'\fP
.br
\fC#include 'opal/threads/mutex.h'\fP
.br
\fC#include 'opal/threads/condition.h'\fP
.br
\fC#include 'mca/oob/tcp/oob_tcp_peer.h'\fP
.br
\fC#include 'mca/oob/tcp/oob_tcp_msg.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBOMPI_PROCESS_NAME_HTON\fP(n)"
.br
.RI "\fIConvert process name from host to network byte order. \fP"
.ti -1c
.RI "#define \fBOMPI_PROCESS_NAME_NTOH\fP(n)"
.br
.RI "\fIConvert process name from network to host byte order. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBmca_oob_tcp_component_t\fP \fBmca_oob_tcp_component_t\fP"
.br
.RI "\fIConvenience Typedef. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBmca_oob_tcp_component_open\fP (void)"
.br
.ti -1c
.RI "int \fBmca_oob_tcp_component_close\fP (void)"
.br
.ti -1c
.RI "\fBmca_oob_t\fP * \fBmca_oob_tcp_component_init\fP (int *priority)"
.br
.ti -1c
.RI "int \fBmca_oob_tcp_init\fP (void)"
.br
.RI "\fIHook function to allow the selected oob components to register their contact info with the registry. \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_fini\fP (void)"
.br
.RI "\fICleanup resources during shutdown. \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_process_name_compare\fP (const orte_process_name_t *n1, const orte_process_name_t *n2)"
.br
.RI "\fICompare two process names for equality. \fP"
.ti -1c
.RI "char * \fBmca_oob_tcp_get_addr\fP (void)"
.br
.RI "\fIObtain contact information for this host (e.g. \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_set_addr\fP (const orte_process_name_t *, const char *)"
.br
.RI "\fISetup cached addresses for the peers. \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_ping\fP (const orte_process_name_t *, const char *uri, const struct timeval *tv)"
.br
.RI "\fIA routine to ping a given process name to determine if it is reachable. \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_send\fP (orte_process_name_t *peer, struct iovec *msg, int count, int tag, int flags)"
.br
.RI "\fISimiliar to unix writev(2). \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_recv\fP (orte_process_name_t *peer, struct iovec *msg, int count, int tag, int flags)"
.br
.RI "\fISimiliar to unix readv(2). \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_send_nb\fP (orte_process_name_t *peer, struct iovec *msg, int count, int tag, int flags, \fBmca_oob_callback_fn_t\fP cbfunc, void *cbdata)"
.br
.RI "\fINon-blocking version of \fBmca_oob_send()\fP. \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_recv_nb\fP (orte_process_name_t *peer, struct iovec *msg, int count, int tag, int flags, \fBmca_oob_callback_fn_t\fP cbfunc, void *cbdata)"
.br
.RI "\fINon-blocking version of \fBmca_oob_recv()\fP. \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_recv_cancel\fP (orte_process_name_t *peer, int tag)"
.br
.RI "\fICancel non-blocking receive. \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_resolve\fP (\fBmca_oob_tcp_peer_t\fP *)"
.br
.RI "\fIAttempt to map a peer name to its corresponding address. \fP"
.ti -1c
.RI "int \fBmca_oob_tcp_parse_uri\fP (const char *uri, struct sockaddr_in *inaddr)"
.br
.RI "\fIParse a URI string into an IP address and port number. \fP"
.ti -1c
.RI "void \fBmca_oob_tcp_registry_callback\fP (\fBorte_gpr_notify_data_t\fP *data, void *cbdata)"
.br
.RI "\fICallback from registry on change to subscribed segments. \fP"
.ti -1c
.RI "void \fBmca_oob_tcp_set_socket_options\fP (int sd)"
.br
.RI "\fISetup socket options. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_COMP_EXPORT \fBmca_oob_tcp_component_t\fP \fBmca_oob_tcp_component\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
Defines the functions for the tcp module. 


.SH "Define Documentation"
.PP 
.SS "#define OMPI_PROCESS_NAME_HTON(n)"
.PP
\fBValue:\fP
.PP
.nf
n.cellid = htonl(n.cellid); \
    n.jobid = htonl(n.jobid); \
    n.vpid = htonl(n.vpid);
.fi
Convert process name from host to network byte order. 
.PP
\fBParameters:\fP
.RS 4
\fIname\fP .RE
.PP

.SS "#define OMPI_PROCESS_NAME_NTOH(n)"
.PP
\fBValue:\fP
.PP
.nf
n.cellid = ntohl(n.cellid); \
    n.jobid = ntohl(n.jobid); \
    n.vpid = ntohl(n.vpid);
.fi
Convert process name from network to host byte order. 
.PP
\fBParameters:\fP
.RS 4
\fIname\fP .RE
.PP

.SH "Function Documentation"
.PP 
.SS "char* mca_oob_tcp_get_addr (void)"
.PP
Obtain contact information for this host (e.g. 
.PP
<ipaddress>:<port>) 
.SS "int mca_oob_tcp_ping (const orte_process_name_t *, const char * uri, const struct timeval * tv)"
.PP
A routine to ping a given process name to determine if it is reachable. 
.PP
\fBParameters:\fP
.RS 4
\fIname\fP The peer name. 
.br
\fItv\fP The length of time to wait on a connection/response.
.RE
.PP
Note that this routine blocks up to the specified timeout waiting for a connection / response from the specified peer. If the peer is unavailable an error status is returned. 
.SS "int mca_oob_tcp_process_name_compare (const orte_process_name_t * n1, const orte_process_name_t * n2)"
.PP
Compare two process names for equality. 
.PP
\fBParameters:\fP
.RS 4
\fIn1\fP Process name 1. 
.br
\fIn2\fP Process name 2. 
.RE
.PP
\fBReturns:\fP
.RS 4
(-1 for n1<n2 0 for equality, 1 for n1>n2)
.RE
.PP
Note that the definition of < or > is somewhat arbitrary - just needs to be consistently applied to maintain an ordering when process names are used as indices. 
.SS "int mca_oob_tcp_recv (orte_process_name_t * peer, struct iovec * msg, int count, int tag, int flags)"
.PP
Similiar to unix readv(2). 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process or MCA_OOB_NAME_ANY for wildcard receive. 
.br
\fImsg\fP (IN) Array of iovecs describing user buffers and lengths. 
.br
\fIcount\fP (IN) Number of elements in iovec array. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIflags\fP (IN) May be MCA_OOB_PEEK to return up to the number of bytes provided in the iovec array without removing the message from the queue. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error or number of bytes actually received. 
.RE
.PP

.SS "int mca_oob_tcp_recv_cancel (orte_process_name_t * peer, int tag)"
.PP
Cancel non-blocking receive. 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process or MCA_OOB_NAME_ANY for wildcard receive. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error or number of bytes actually received. 
.RE
.PP

.SS "int mca_oob_tcp_recv_nb (orte_process_name_t * peer, struct iovec * msg, int count, int tag, int flags, \fBmca_oob_callback_fn_t\fP cbfunc, void * cbdata)"
.PP
Non-blocking version of \fBmca_oob_recv()\fP. 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process or MCA_OOB_NAME_ANY for wildcard receive. 
.br
\fImsg\fP (IN) Array of iovecs describing user buffers and lengths. 
.br
\fIcount\fP (IN) Number of elements in iovec array. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIflags\fP (IN) May be MCA_OOB_PEEK to return up to size bytes of msg w/out removing it from the queue, 
.br
\fIcbfunc\fP (IN) Callback function on recv completion. 
.br
\fIcbdata\fP (IN) User data that is passed to callback function. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error or number of bytes actually received. 
.RE
.PP

.SS "int mca_oob_tcp_send (orte_process_name_t * peer, struct iovec * msg, int count, int tag, int flags)"
.PP
Similiar to unix writev(2). 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process. 
.br
\fImsg\fP (IN) Array of iovecs describing user buffers and lengths. 
.br
\fIcount\fP (IN) Number of elements in iovec array. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIflags\fP (IN) Currently unused. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error number of bytes actually sent. 
.RE
.PP

.SS "int mca_oob_tcp_send_nb (orte_process_name_t * peer, struct iovec * msg, int count, int tag, int flags, \fBmca_oob_callback_fn_t\fP cbfunc, void * cbdata)"
.PP
Non-blocking version of \fBmca_oob_send()\fP. 
.PP
\fBParameters:\fP
.RS 4
\fIpeer\fP (IN) Opaque name of peer process. 
.br
\fImsg\fP (IN) Array of iovecs describing user buffers and lengths. 
.br
\fIcount\fP (IN) Number of elements in iovec array. 
.br
\fItag\fP (IN) User defined tag for matching send/recv. 
.br
\fIflags\fP (IN) Currently unused. 
.br
\fIcbfunc\fP (IN) Callback function on send completion. 
.br
\fIcbdata\fP (IN) User data that is passed to callback function. 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code (<0) on error number of bytes actually sent. 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
